diff -uNrd ircd-hybrid-6.4.1/src/parse.c ircd-hyb6.4.1-FDFr5.4/src/parse.c
--- ircd-hybrid-6.4.1/src/parse.c	Sat Aug 16 15:10:45 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/parse.c	Wed Oct 15 20:38:23 2003
@@ -17,7 +17,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: parse.c,v 1.53 2003/08/16 19:10:45 ievil Exp $
+ *   $Id: parse.c,v 1.1.1.2 2003/10/09 02:47:15 jailbird Exp $
  */
 #include "parse.h"
 #include "channel.h"
diff -uNrd ircd-hybrid-6.4.1/src/restart.c ircd-hyb6.4.1-FDFr5.4/src/restart.c
--- ircd-hybrid-6.4.1/src/restart.c	Mon Jun 23 23:57:16 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/restart.c	Wed Oct 15 20:38:23 2003
@@ -1,7 +1,7 @@
 /*
  * restart.c
  *
- * $Id: restart.c,v 1.12 2003/06/24 03:57:16 ievil Exp $
+ * $Id: restart.c,v 1.1.1.2 2003/10/09 02:47:15 jailbird Exp $
  */
 #include "restart.h"
 #include "common.h"
diff -uNrd ircd-hybrid-6.4.1/src/s_auth.c ircd-hyb6.4.1-FDFr5.4/src/s_auth.c
--- ircd-hybrid-6.4.1/src/s_auth.c	Mon Jun 23 23:57:16 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/s_auth.c	Wed Oct 15 20:38:23 2003
@@ -16,7 +16,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: s_auth.c,v 1.57 2003/06/24 03:57:16 ievil Exp $
+ *   $Id: s_auth.c,v 1.1.1.2 2003/10/09 02:47:14 jailbird Exp $
  *
  * Changes:
  *   July 6, 1999 - Rewrote most of the code here. When a client connects
diff -uNrd ircd-hybrid-6.4.1/src/s_bsd.c ircd-hyb6.4.1-FDFr5.4/src/s_bsd.c
--- ircd-hybrid-6.4.1/src/s_bsd.c	Mon Jun 23 23:57:17 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/s_bsd.c	Wed Oct 15 20:38:22 2003
@@ -17,7 +17,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: s_bsd.c,v 1.148 2003/06/24 03:57:17 ievil Exp $
+ *  $Id: s_bsd.c,v 1.1.1.2 2003/10/09 02:47:14 jailbird Exp $
  */
 #include "s_bsd.h"
 #include "class.h"
diff -uNrd ircd-hybrid-6.4.1/src/s_conf.c ircd-hyb6.4.1-FDFr5.4/src/s_conf.c
--- ircd-hybrid-6.4.1/src/s_conf.c	Sat Aug 16 15:19:41 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/s_conf.c	Wed Oct 15 20:38:23 2003
@@ -19,7 +19,7 @@
  *
  *  (C) 1988 University of Oulu,Computing Center and Jarkko Oikarinen"
  *
- *  $Id: s_conf.c,v 1.248 2003/08/16 19:19:41 ievil Exp $
+ *  $Id: s_conf.c,v 1.5 2003/10/09 03:49:54 jailbird Exp $
  */
 #include "m_commands.h"
 #include "s_conf.h"
@@ -95,10 +95,7 @@
 
 /* externally defined functions */
 extern  void    outofmemory(void);        /* defined in list.c */
-
-#ifdef GLINES
 extern  struct ConfItem *find_gkill(aClient *,char *); /* defined in m_gline.c */
-#endif
 
 /* usually, with hash tables, you use a prime number...
  * but in this case I am dealing with ip addresses, not ascii strings.
@@ -142,6 +139,9 @@
 /* conf uline link list root */
 struct ConfItem        *u_conf = ((struct ConfItem *)NULL);
 
+/* conf sline link list root */
+struct ConfItem        *s_conf = ((struct ConfItem *)NULL);
+
 /* keep track of .include files to hash in */
 struct ConfItem        *include_list = ((struct ConfItem *)NULL);
 
@@ -378,6 +378,8 @@
     this_conf = x_conf;
   else if (flags & CONF_ULINE)
     this_conf = u_conf;
+  else if (flags & CONF_SLINE)
+    this_conf = s_conf;
   else return;
 
   for (aconf = this_conf; aconf; aconf = aconf->next)
@@ -435,9 +437,7 @@
 verify_access(struct Client *cptr, const char* username, char **preason)
 {
   struct ConfItem* aconf;
-#ifdef GLINES
   struct ConfItem* gkill_conf;
-#endif /* GLINES */
   struct ConfItem* tkline_conf;
   char       non_ident[USERLEN + 1];
 
@@ -469,7 +469,6 @@
     {
       if (aconf->status & CONF_CLIENT)
         {
-#ifdef GLINES
           if ( !IsConfElined(aconf) && !IsConfExemptGline(aconf) )
             {
               if (IsGotId(cptr))
@@ -484,10 +483,6 @@
                   return ( -5 );
                 }
             }
-#endif        /* GLINES */
-
-          if(IsConfDoIdentd(aconf))
-            SetNeedId(cptr);
 
           /* Thanks for spoof idea amm */
           if(IsConfDoSpoofIp(aconf))
@@ -1395,6 +1390,8 @@
     this_conf = x_conf;
   else if(mask & CONF_ULINE)
     this_conf = u_conf;
+  else if(mask & CONF_SLINE)
+    this_conf = s_conf;
   else
     return((struct ConfItem *)NULL);
 
@@ -2096,6 +2093,11 @@
           aconf->status = CONF_QUARANTINED_NICK;
           break;
 
+        case 'S': /* Service, ie host/client is completely */
+	case 's': /* trusted and all-powerful.             */
+          aconf->status = CONF_SLINE;
+          break;
+
         case 'U': /* Uphost, ie. host where client reading */
         case 'u': /* this should connect.                  */
           aconf->status = CONF_ULINE;
@@ -2424,7 +2426,6 @@
           if( (p = strchr(aconf->host,'@')))
             {
               char* x;
-              aconf->flags |= CONF_FLAGS_DO_IDENTD;
               *p++ = '\0';
               MyFree(aconf->user);
               DupString(aconf->user, aconf->host);
@@ -2455,7 +2456,6 @@
 
 	       if( (p = strchr(aconf->user,'@')) )
 		 {
-		   aconf->flags |= CONF_FLAGS_DO_IDENTD;
 		   *p = '\0';
 		   p++;
 		   MyFree(aconf->host);
@@ -2521,6 +2521,16 @@
           aconf->next = u_conf;
           u_conf = aconf;
         }
+      else if (aconf->status & CONF_SLINE)
+        {
+          dontadd = 1;
+          MyFree(aconf->user);
+          aconf->user = (char *)NULL;
+          aconf->name = aconf->host;
+	  aconf->host = (char *)NULL;
+          aconf->next = s_conf;
+          s_conf = aconf;
+        }
       else if (aconf->status & CONF_QUARANTINED_NICK)
         {
           dontadd = 1;
@@ -3004,12 +3014,10 @@
         int_privs |= CONF_OPER_K;
       else if(*privs == 'k')                /* disallow kill and kline privs */
         int_privs &= ~CONF_OPER_K;
-#ifdef GLINES
       else if(*privs == 'G')                /* allow gline */
         int_privs |= CONF_OPER_GLINE;
       else if(*privs == 'g')                /* disallow gline */
         int_privs &= ~CONF_OPER_GLINE;
-#endif
       else if(*privs == 'H')                /* allow rehash */
         int_privs |= CONF_OPER_REHASH;
       else if(*privs == 'h')                /* disallow rehash */
@@ -3751,6 +3759,7 @@
     zap_Dlines();
     clear_special_conf(&x_conf);
     clear_special_conf(&u_conf);
+    clear_special_conf(&s_conf);
     clear_q_lines();
     mark_listeners_closing();
 }
diff -uNrd ircd-hybrid-6.4.1/src/s_debug.c ircd-hyb6.4.1-FDFr5.4/src/s_debug.c
--- ircd-hybrid-6.4.1/src/s_debug.c	Sat Aug 16 15:58:36 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/s_debug.c	Wed Oct 15 20:38:22 2003
@@ -17,7 +17,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: s_debug.c,v 1.61 2003/08/16 19:58:36 ievil Exp $
+ *   $Id: s_debug.c,v 1.4 2003/10/09 03:49:54 jailbird Exp $
  */
 #include "s_debug.h"
 #include "channel.h"
@@ -66,12 +66,7 @@
 #ifdef CHANMODE_E
   'e',
 #endif
-#ifdef NO_FAKE_GLINES
-  'g',
-#endif
-#ifdef GLINES
   'G',
-#endif
 #ifdef  HUB
   'H',
 #endif
@@ -118,9 +113,7 @@
 /* th+hybrid servers ALWAYS do TS_WARNINGS */
   'o',
   'w',
-#ifdef TS5_ONLY
   'c',
-#endif  
   '\0'
 };
 
@@ -313,34 +306,28 @@
         {
           chb++;
           chbm += (strlen(gen_link->value.cp)+1+sizeof(Link));
-        #ifdef BAN_INFO
         	if (gen_link->value.banptr->banstr)
         		chbm += strlen(gen_link->value.banptr->banstr);
         	if (gen_link->value.banptr->who)
         		chbm += strlen(gen_link->value.banptr->who);
-        #endif /* BAN_INFO */
         }
       for (gen_link = chptr->exceptlist; gen_link; gen_link = gen_link->next)
       {
         che++;
 	chem += (strlen(gen_link->value.cp)+1+sizeof(Link));
-      #ifdef BAN_INFO
       		if (gen_link->value.banptr->banstr)
 			chem += strlen(gen_link->value.banptr->banstr);
 		if (gen_link->value.banptr->who)
 			chem += strlen(gen_link->value.banptr->who);
-      #endif
       }
       for (gen_link = chptr->invexlist; gen_link; gen_link = gen_link->next)
       {
         che++;
         chem += (strlen(gen_link->value.cp)+1+sizeof(Link));
-      #ifdef BAN_INFO
                 if (gen_link->value.banptr->banstr)
                         chem += strlen(gen_link->value.banptr->banstr);
                 if (gen_link->value.banptr->who)
                         chem += strlen(gen_link->value.banptr->who);
-      #endif
       }
     }
 
diff -uNrd ircd-hybrid-6.4.1/src/s_log.c ircd-hyb6.4.1-FDFr5.4/src/s_log.c
--- ircd-hybrid-6.4.1/src/s_log.c	Mon Jun 23 23:57:17 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/s_log.c	Wed Oct 15 20:38:22 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: s_log.c,v 1.15 2003/06/24 03:57:17 ievil Exp $
+ *   $Id: s_log.c,v 1.1.1.2 2003/10/09 02:47:14 jailbird Exp $
  */
 #include "s_log.h"
 #include "irc_string.h"
diff -uNrd ircd-hybrid-6.4.1/src/s_misc.c ircd-hyb6.4.1-FDFr5.4/src/s_misc.c
--- ircd-hybrid-6.4.1/src/s_misc.c	Thu Aug 21 19:59:26 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/s_misc.c	Sun Oct 26 14:35:13 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: s_misc.c,v 1.79 2003/08/21 23:59:26 ievil Exp $
+ *  $Id: s_misc.c,v 1.3 2003/10/09 03:49:54 jailbird Exp $
  */
 #include "s_misc.h"
 #include "channel.h"
@@ -111,7 +111,6 @@
 }
 
 
-#if defined(GLINES)
 /*
  * small_file_date
  * Make a small YYYYMMDD formatted string suitable for a
@@ -128,7 +127,6 @@
   strftime(timebuffer, MAX_DATE_STRING, "%Y%m%d", tmptr);
   return timebuffer;
 }
-#endif
 
 /*
  * Retarded - so sue me :-P
@@ -237,7 +235,7 @@
                         TOPICLEN,
                         KILLLEN );
 
-  ircsprintf(cbmodes,  "CHANMODES=b%s%s,k,l,imnpst", 
+  ircsprintf(cbmodes,  "CHANMODES=bc%s%s,k,l,imnpst", 
                         mode_e ? "e" : "",
                         mode_I ? "I" : "");
 
diff -uNrd ircd-hybrid-6.4.1/src/s_serv.c ircd-hyb6.4.1-FDFr5.4/src/s_serv.c
--- ircd-hybrid-6.4.1/src/s_serv.c	Sat Aug 16 15:58:36 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/s_serv.c	Wed Oct 15 20:38:23 2003
@@ -19,7 +19,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: s_serv.c,v 1.235 2003/08/16 19:58:36 ievil Exp $
+ *   $Id: s_serv.c,v 1.4 2003/10/09 03:49:54 jailbird Exp $
  */
 #include "s_serv.h"
 #include "channel.h"
@@ -74,6 +74,7 @@
   { "EX",       CAP_EX },
   { "CHW",      CAP_CHW },
   { "KNOCK",    CAP_KNOCK },
+  { "FDF",      CAP_FDF },
 #ifdef HUB
   { "KLN",      CAP_KLN }, 
   { "UNKLN",    CAP_UNKLN },
diff -uNrd ircd-hybrid-6.4.1/src/s_stats.c ircd-hyb6.4.1-FDFr5.4/src/s_stats.c
--- ircd-hybrid-6.4.1/src/s_stats.c	Fri Jul 30 16:10:54 1999
+++ ircd-hyb6.4.1-FDFr5.4/src/s_stats.c	Wed Oct 15 20:38:23 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: s_stats.c,v 1.1 1999/07/30 20:10:54 tomh Exp $
+ *  $Id: s_stats.c,v 1.1.1.1 2003/05/09 01:49:28 jailbird Exp $
  */
 #include "s_stats.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.4.1/src/s_user.c ircd-hyb6.4.1-FDFr5.4/src/s_user.c
--- ircd-hybrid-6.4.1/src/s_user.c	Thu Aug 21 19:59:26 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/s_user.c	Sun Oct 26 12:51:48 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: s_user.c,v 1.266 2003/08/21 23:59:26 ievil Exp $
+ *  $Id: s_user.c,v 1.10 2003/10/26 17:51:48 jailbird Exp $
  */
 #include "m_commands.h"
 #include "s_user.h"
@@ -505,6 +505,84 @@
 
 
 /*
+ *  check_clones
+ *    This function counts the number of clients with the
+ *    same host as cptr that connected less than CHECK_CLONE_PERIOD
+ *    seconds ago.
+ *  return value
+ *    -1: reject connections
+ *     0: permit connections
+ *  -SeKs -record
+ */
+#ifdef CHECK_CLONE
+static int check_clones(aClient * cptr)
+{
+  struct abacklog
+  {
+    time_t last;
+    char host[HOSTLEN];
+    int count;
+    struct abacklog *next;
+  };
+
+  static struct abacklog *backlog = NULL;
+  register struct abacklog **blscn = &backlog, *blptr;
+
+  /* Find the host we're interested in. While we're at it, we'll
+   * clean out expired elements from the list.                    */
+
+  while ((*blscn != NULL) && (strcmp(cptr->host, (*blscn)->host))) {
+    if ((*blscn)->last + CHECK_CLONE_PERIOD < CurrentTime) {
+      /* expired; remove */
+      if ((*blscn)->count == -1)
+        sendto_ops("Removing throttle for %s.", (*blscn)->host);
+      blptr = *blscn;
+      *blscn = blptr->next;
+      MyFree((char *)blptr);
+    } else
+      blscn = &(*blscn)->next;
+  }
+
+  if (*blscn) {
+    /* There is a record for this host */
+    if (!((*blscn)->last + CHECK_CLONE_PERIOD < CurrentTime)) {
+      /* not expired */
+      (*blscn)->last = CurrentTime;
+      if ((*blscn)->count == -1)
+        return (-1);
+      else {
+        (*blscn)->count++;
+        if (((*blscn)->count == CHECK_CLONE_LIMIT) && !IsFlined(cptr)) {
+          sendto_ops("Throttling connections from %s.", (*blscn)->host);
+          (*blscn)->count = -1;
+          return (-1);
+        }
+        else
+          return (0);
+      }
+    } else {
+      /* expired */
+      if ((*blscn)->count == -1)
+        sendto_ops("Removing throttle for %s.", (*blscn)->host);
+      (*blscn)->last = CurrentTime;
+      (*blscn)->count = 1;
+      return (0);
+    }
+  } else {
+    /* no record for host; make one */
+    blptr = (struct abacklog *)MyMalloc(sizeof(struct abacklog));
+    strncpy_irc(blptr->host, cptr->host, HOSTLEN);
+    blptr->next = backlog;
+    blptr->last = CurrentTime;
+    blptr->count = 1;
+    backlog = blptr;
+    return (0);
+  }
+}
+#endif
+
+
+/*
 ** register_user
 **      This function is called when both NICK and USER messages
 **      have been accepted for the client, in whatever order. Only
@@ -528,7 +606,7 @@
 **         nick from local user or kill him/her...
 */
 
-static int register_user(aClient *cptr, aClient *sptr, 
+int register_user(aClient *cptr, aClient *sptr, 
                          char *nick, char *username)
 {
   aConfItem*  aconf;
@@ -620,7 +698,7 @@
           {
             if (!IsGotId(sptr))
               {
-                if (IsNeedId(sptr))
+                if (!IsNoTilde(sptr))
                   {
                     *sptr->username = '~';
                     strncpy_irc(&sptr->username[1], username, USERLEN - 1);
@@ -674,6 +752,9 @@
              {
                 *sptr->username = '~';
                 strncpy_irc(&sptr->username[1], username, USERLEN - 1);
+                sendto_one(sptr,
+ ":%s NOTICE %s :*** Notice -- You need to install identd if you wish to have your username show up without the ~ (tilde)",
+                           me.name, cptr->name);
              }
            sptr->username[USERLEN] = '\0';
         }
@@ -724,6 +805,25 @@
         }
       /* end of valid user name check */
 
+#ifdef CHECK_CLONE
+
+        /*
+         * Add this local client into the clone check database.  If the
+         * site has been throttled, reject the user. -SeKs -record
+         */
+
+        if (check_clones(sptr) == -1
+#ifdef CHECK_CLONE_DELAY
+            && me.since + CHECK_CLONE_DELAY < CurrentTime
+#endif
+            )
+        {
+          ServerStats->is_ref++;
+          return exit_client(cptr, sptr, &me,
+            "Too many connections from your host -- throttled");
+        }
+#endif
+
       if(!IsAnOper(sptr))
         {
           char *xreason;
@@ -805,7 +905,7 @@
 
   if (MyConnect(sptr))
     {
-      sendto_one(sptr, form_str(RPL_WELCOME), me.name, nick, nick);
+      sendto_one(sptr, form_str(RPL_WELCOME), me.name, nick, NETWORK_NAME, nick);
       /* This is a duplicate of the NOTICE but see below...*/
       sendto_one(sptr, form_str(RPL_YOURHOST), me.name, nick,
                  get_listener_name(sptr->listener), ircd_version);
@@ -912,6 +1012,11 @@
       ubuf[1] = '\0';
     }
   
+#ifdef CHECK_CLONE
+        if (!IsSLine(sptr))
+                check_clones(sptr);
+#endif
+
   /* LINKLIST 
    * add to local client link list -Dianora
    * I really want to move this add to link list
@@ -1091,7 +1196,6 @@
          ":%s NOTICE %s :*** You are exempt from K/D/G lines. congrats.",
                  me.name,sptr->name);
     }
-#ifdef GLINES
   else if(IsConfExemptGline(aconf))
     {
       SetExemptGline(sptr);
@@ -1099,7 +1203,6 @@
          ":%s NOTICE %s :*** You are exempt from G lines. congrats.",
                  me.name,sptr->name);
     }
-#endif /* GLINES */
 
   /* If this user is exempt from user limits set it F lined" */
   if(IsConfFlined(aconf))
@@ -1137,6 +1240,7 @@
 static int nickkilldone(aClient *cptr, aClient *sptr, int parc,
                  char *parv[], time_t newts,char *nick)
 {
+	Link	*lp;
 
   if (IsServer(sptr))
     {
@@ -1186,6 +1290,21 @@
     }
   else if (sptr->name[0])
     {
+	/*
+	** If the client belongs to me, then check to see
+	** if client is currently on any channels where it
+	** is currently banned.  If so, do not allow the nick
+	** change to occur.
+	*/
+	if (MyClient(sptr))
+		for (lp = cptr->user->channel; lp; lp = lp->next)
+			if (can_send(cptr, lp->value.chptr) == MODE_BAN) {
+				sendto_one(cptr, form_str(ERR_BANNICKCHANGE),
+					   me.name, parv[0],
+					   lp->value.chptr->chname);
+				return 0;
+			}
+
       /*
       ** Client just changing his/her nick. If he/she is
       ** on a channel, send note of change to all clients
@@ -1234,6 +1353,11 @@
         {
           sendto_common_channels(sptr, ":%s NICK :%s", parv[0], nick);
           if (sptr->user)
+#ifdef ANTI_IP_SPOOF
+            /* Don't send out a nick-change if they haven't PONG'd us
+             * because they haven't registered yet if they haven't! -JailBird */
+            if ((!MyConnect(sptr)) || (sptr->flags2 & FLAGS2_GOT_ANTI_SPOOF_PING))
+#endif
             {
               add_history(sptr,1);
               sendto_serv_butone(cptr, ":%s NICK %s :%lu",
@@ -1262,6 +1386,18 @@
           ** may reject the client and call exit_client for it
           ** --must test this and exit m_nick too!!!
           */
+          /* anti ip sequence prediction spoof code
+             it needs a good going over by someone else, but it
+             works... -Dianora
+           */
+#ifdef ANTI_IP_SPOOF
+        if(MyConnect(sptr)) {
+                strcpy(sptr->name,nick);
+                sptr->random_ping = abs((int)my_rand());
+                sendto_one(sptr, "PING :%d", sptr->random_ping);
+                sptr->flags |= FLAGS_PINGSENT;
+        } else
+#endif
             if (register_user(cptr, sptr, nick, buf) == CLIENT_EXITED)
               return CLIENT_EXITED;
         }
@@ -1910,6 +2046,22 @@
     }
   strncpy_irc(sptr->info, realname, REALLEN);
 
+#ifdef ANTI_IP_SPOOF
+  user->last = CurrentTime;
+  if(MyConnect(sptr))
+     {
+       if (sptr->name[0]) /* NICK already received, now I have USER... */
+         {
+           sptr->random_ping = abs((int)my_rand());
+           sendto_one(sptr, "PING :%d", sptr->random_ping);
+           sptr->flags |= FLAGS_PINGSENT;
+         }
+       if (!IsGotId(sptr))
+         strncpy_irc(sptr->username, username, USERLEN);
+       return 0;
+     }
+#endif
+
   if (sptr->name[0]) /* NICK already received, now I have USER... */
     return register_user(cptr, sptr, sptr->name, username);
   else
@@ -1960,7 +2112,7 @@
       return 0;
     }
 
-  if (IsServer(sptr) || sptr != acptr || acptr->from != sptr->from)
+  if ((IsServer(sptr) && !IsSLine(sptr)) || sptr != acptr || acptr->from != sptr->from)
     {
       if (IsServer(cptr))
         sendto_ops_butone(NULL, &me,
@@ -2221,3 +2373,90 @@
   if (cptr && MyClient(cptr))
     send_umode(cptr, sptr, old, ALL_UMODES, buf);
 }
+
+/*
+** m_snick
+**      parv[0] = sender prefix
+**      parv[1] = original nickname
+**      parv[2] = new nickname
+**      parv[3] = TS
+/* This function is a shameless merger between m_nick and
+   DalNet's m_svsnick().  I have tried to cover any issue
+   that could come up.  -JailBird */
+int m_snick(aClient *cptr, aClient *sptr, int parc, char *parv[])
+{
+  aClient* acptr;
+  char     nick[NICKLEN + 2];
+  char     *s;
+  time_t   newts = 0;
+
+  /* Check to make sure this is comming from a service */
+  if (!IsSLine(sptr))
+      return 0;
+
+  /* Since this is from a service, just return, don't send an error */
+  if (parc < 4)
+      return 0;
+
+  if (s = strchr(parv[2], '~'))
+    *s = '\0';
+
+  /* Terminate the string */
+  strncpy_irc(nick, parv[2], NICKLEN);
+  nick[NICKLEN] = '\0';
+
+  acptr = find_client(parv[1], NULL);
+  /* If the nick was bad, then just ignore the SNICK */
+  if (!clean_nick_name(nick))
+      return 0;
+
+  /* Is the nickname identical to a server's name? */
+  if (find_server(nick) != NULL)
+      return 0;
+
+  /* Do we have a collision situation? */
+  if (find_client(nick, NULL) != NULL)
+      return 0;
+
+  if (hunt_server(cptr, sptr, ":%s SNICK %s %s :%s", 1, parc, parv)
+      ==HUNTED_ISME) {
+    if ((acptr = find_person(parv[1], NULL))) {
+      newts = atol(parv[3]);
+      acptr->tsinfo = newts;
+      sendto_realops_flags(FLAGS_NCHANGE,
+                           "Nick change: From %s to %s [%s@%s]",
+                           parv[1], nick, acptr->username, acptr->host);
+      sendto_common_channels(acptr, ":%s NICK :%s", parv[1], nick);
+      if (acptr->user) {
+        add_history(acptr, 1);
+        sendto_serv_butone(NULL, ":%s NICK %s :%lu", parv[1],
+                           nick, acptr->tsinfo);
+      }
+      if (sptr->name[0])
+        del_from_client_hash_table(acptr->name, acptr);
+      strcpy(acptr->name, nick);
+      add_to_client_hash_table(nick, acptr);
+    }
+  }
+  return 0;
+}
+
+/* check to see if the message has any color chars in it. */
+int msg_has_colors(char *msg)
+{   
+   char *c = msg; 
+      
+   while(*c)
+   {  
+      if(*c == '\003' || *c == '\033')
+         break;
+      else
+         c++;
+   }      
+            
+   if(*c)   
+      return 1;
+                
+   return 0;
+}
+
diff -uNrd ircd-hybrid-6.4.1/src/s_zip.c ircd-hyb6.4.1-FDFr5.4/src/s_zip.c
--- ircd-hybrid-6.4.1/src/s_zip.c	Wed Nov 27 23:18:01 2002
+++ ircd-hyb6.4.1-FDFr5.4/src/s_zip.c	Wed Oct 15 20:38:22 2003
@@ -16,7 +16,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: s_zip.c,v 1.26 2002/11/28 04:18:01 db Exp $
+ *   $Id: s_zip.c,v 1.1.1.2 2003/10/09 02:47:14 jailbird Exp $
  */
 #include "client.h"
 #include "s_zip.h"
diff -uNrd ircd-hybrid-6.4.1/src/scache.c ircd-hyb6.4.1-FDFr5.4/src/scache.c
--- ircd-hybrid-6.4.1/src/scache.c	Tue Jul 17 21:37:18 2001
+++ ircd-hyb6.4.1-FDFr5.4/src/scache.c	Wed Oct 15 20:38:22 2003
@@ -1,7 +1,7 @@
 /*
  * scache.c
  *
- * $Id: scache.c,v 1.17 2001/07/18 01:37:18 lusky Exp $
+ * $Id: scache.c,v 1.1.1.1 2003/05/09 01:49:28 jailbird Exp $
  */
 
 #include "client.h"
diff -uNrd ircd-hybrid-6.4.1/src/send.c ircd-hyb6.4.1-FDFr5.4/src/send.c
--- ircd-hybrid-6.4.1/src/send.c	Mon Jun 23 23:57:17 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/send.c	Wed Oct 15 20:38:23 2003
@@ -17,7 +17,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: send.c,v 1.118 2003/06/24 03:57:17 ievil Exp $
+ *   $Id: send.c,v 1.3 2003/10/09 03:49:54 jailbird Exp $
  */
 #include "send.h"
 #include "channel.h"
@@ -489,16 +489,18 @@
    * of an overflow.
    * -wnder
    */
+   /* Always #define IRCII_KLUDGE and break the RFC by only sending
+    * \n and NOT \r\n. This allows DCC RAW connections to work.
+    * -JailBird
+    */
         if (len > 510)
         {
-                sendbuf[510] = '\r';
-                sendbuf[511] = '\n';
-                sendbuf[512] = '\0';
-                len = 512;
+                sendbuf[510] = '\n';
+                sendbuf[511] = '\0';
+                len = 511;
         }
         else
         {
-                sendbuf[len++] = '\r';
                 sendbuf[len++] = '\n';
                 sendbuf[len] = '\0';
         }
diff -uNrd ircd-hybrid-6.4.1/src/sprintf_irc.c ircd-hyb6.4.1-FDFr5.4/src/sprintf_irc.c
--- ircd-hybrid-6.4.1/src/sprintf_irc.c	Wed Jun 12 15:31:22 2002
+++ ircd-hyb6.4.1-FDFr5.4/src/sprintf_irc.c	Wed Oct 15 20:38:23 2003
@@ -17,7 +17,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: sprintf_irc.c,v 1.12 2002/06/12 19:31:22 androsyn Exp $
+ *   $Id: sprintf_irc.c,v 1.1.1.2 2003/10/09 02:47:15 jailbird Exp $
  */
 #include "sprintf_irc.h"
 
diff -uNrd ircd-hybrid-6.4.1/src/version.c.SH ircd-hyb6.4.1-FDFr5.4/src/version.c.SH
--- ircd-hybrid-6.4.1/src/version.c.SH	Tue Jun 24 00:19:30 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/version.c.SH	Sun Oct 26 13:01:31 2003
@@ -1,6 +1,6 @@
 #!/bin/sh
 
-# $Id: version.c.SH,v 1.26 2003/06/24 04:19:30 ievil Exp $
+# $Id: version.c.SH,v 1.3 2003/10/09 03:49:54 jailbird Exp $
 
 spitshell=cat
 package=IRC
@@ -79,6 +79,19 @@
 echo "  \"$i\"," >> version.c
 done
 $spitshell >>version.c <<!SUB!THISTOO!
+  "",
+  "The FDFnet ircd coding team consists of the following people:",
+  "",
+  "JailBird            Dustin Marquess     jailbird@alcatraz.fdf.net",
+  "Runt                John Leslie         john@stf.org",
+  "inubus              Steve White         subuni@users.sourceforge.net",
+  "",
+  "The following people helped contribute code to the FDFnet ircd project",
+  "by supplying code, ideas, etc:",
+  "",
+  "Raistlin     SPaM     Ryan     Viv",
+  "",
+  "The FDFnet ircd was developed on the Linux operating system",
   "",
   0,
 };
diff -uNrd ircd-hybrid-6.4.1/src/whowas.c ircd-hyb6.4.1-FDFr5.4/src/whowas.c
--- ircd-hybrid-6.4.1/src/whowas.c	Tue Jul 17 22:30:34 2001
+++ ircd-hyb6.4.1-FDFr5.4/src/whowas.c	Wed Oct 15 20:38:23 2003
@@ -16,7 +16,7 @@
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
-*   $Id: whowas.c,v 1.34 2001/07/18 02:30:34 lusky Exp $
+*   $Id: whowas.c,v 1.1.1.1 2003/05/09 01:49:28 jailbird Exp $
 */
 #include "whowas.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.4.1/tools/README ircd-hyb6.4.1-FDFr5.4/tools/README
--- ircd-hybrid-6.4.1/tools/README	Fri Dec  7 20:59:19 2001
+++ ircd-hyb6.4.1-FDFr5.4/tools/README	Wed Oct 15 20:38:23 2003
@@ -1,4 +1,4 @@
-$Id: README,v 1.6 2001/12/08 01:59:19 wcampbel Exp $
+$Id: README,v 1.1.1.1 2003/05/09 01:49:28 jailbird Exp $
 
 A directory of support programs for ircd.
 
diff -uNrd ircd-hybrid-6.4.1/tools/fixklines.c ircd-hyb6.4.1-FDFr5.4/tools/fixklines.c
--- ircd-hybrid-6.4.1/tools/fixklines.c	Sat Dec  8 02:06:18 2001
+++ ircd-hyb6.4.1-FDFr5.4/tools/fixklines.c	Wed Oct 15 20:38:23 2003
@@ -1,6 +1,6 @@
 /*
 fixklines - scan an ircd.conf or kline.conf file
-$Id: fixklines.c,v 1.5 2001/12/08 07:06:18 lusky Exp $
+$Id: fixklines.c,v 1.1.1.1 2003/05/09 01:49:28 jailbird Exp $
 
   D lines of form
   D:192.168.0.* are converted to D:192.168.0.0/24
diff -uNrd ircd-hybrid-6.4.1/tools/install_ircd ircd-hyb6.4.1-FDFr5.4/tools/install_ircd
--- ircd-hybrid-6.4.1/tools/install_ircd	Thu May 15 00:13:32 2003
+++ ircd-hyb6.4.1-FDFr5.4/tools/install_ircd	Wed Oct 15 20:38:23 2003
@@ -1,6 +1,6 @@
 #!/bin/sh
 # IRCD INSTALL SCRIPT
-# $Id: install_ircd,v 1.10 2003/05/15 04:13:32 db Exp $
+# $Id: install_ircd,v 1.3 2003/10/09 03:49:54 jailbird Exp $
 #
 # Completely re-written by FlashMan <chuegen@quadrunner.com> 981231
 # Wow.  The old version was *very* messy and had boatloads of redundancy.
@@ -47,6 +47,8 @@
 LPATH=`grep '#define.LPATH' include/config.h|awk '{print $3}'|tr -d \"`;
 PPATH=`grep '#define.PPATH' include/config.h|awk '{print $3}'|tr -d \"`;
 HPATH=`grep '#define.HPATH' include/config.h|awk '{print $3}'|tr -d \"`;
+OPATH=`grep '#define.OPATH' include/config.h|awk '{print $3}'|tr -d \"`;
+DLPATH=`grep '#define.DLPATH' include/config.h|awk '{print $3}'|tr -d \"`;
 
 SPATH=`dir_concat ${SPATH}`;
 CPATH=`dir_concat ${CPATH}`;
@@ -55,6 +57,8 @@
 LPATH=`dir_concat ${LPATH}`;
 PPATH=`dir_concat ${PPATH}`;
 HPATH=`dir_concat ${HPATH}`;
+OPATH=`dir_concat ${OPATH}`;
+DLPATH=`dir_concat ${DLPATH}`;
 
 #   DPATH = directory,
 #   SPATH = server executable,
@@ -116,13 +120,30 @@
 dir_make `dirname ${HPATH}`
 if [ ! -f ${HPATH} ]; then
   echo installing opers.txt as ${HPATH}
-  $INSTALL_SH -c opers.txt ${HPATH};
+  $INSTALL_SH -c src/opers.txt ${HPATH};
 else
    echo installing opers.txt as ${HPATH}
    echo previous opers.txt saved as opers.txt.old
    mv ${HPATH} ${HPATH}.old
-   $INSTALL_SH -c opers.txt ${HPATH};
+   $INSTALL_SH -c src/opers.txt ${HPATH};
 fi
+
+# try to install their opers.motd file, in all cases 
+dir_make `dirname ${OPATH}`
+if [ ! -f ${OPATH} ]; then
+  echo installing opers.motd as ${OPATH}
+  $INSTALL_SH -c src/opers.motd ${OPATH};
+else
+   echo installing opers.motd as ${OPATH}
+   echo previous opers.motd saved as opers.motd.old
+   mv ${OPATH} ${OPATH}.old
+   $INSTALL_SH -c src/opers.motd ${OPATH};
+fi
+
+# try to make a blank kline.conf
+dir_make `dirname ${DLPATH}`
+echo touching ${DLPATH}
+touch ${DLPATH}
 
 # install mkpasswd
 if [ ! -f ${DPATH}mkpasswd ]; then
diff -uNrd ircd-hybrid-6.4.1/tools/ircd_start.c ircd-hyb6.4.1-FDFr5.4/tools/ircd_start.c
--- ircd-hybrid-6.4.1/tools/ircd_start.c	Thu Oct  5 23:01:03 2000
+++ ircd-hyb6.4.1-FDFr5.4/tools/ircd_start.c	Wed Oct 15 20:38:23 2003
@@ -1,6 +1,6 @@
 /*
  * contributed by mjr
- * $Id: ircd_start.c,v 1.2 2000/10/06 03:01:03 lusky Exp $
+ * $Id: ircd_start.c,v 1.1.1.1 2003/05/09 01:49:28 jailbird Exp $
  */
 
 #include <stdio.h>
diff -uNrd ircd-hybrid-6.4.1/tools/klineParse.c ircd-hyb6.4.1-FDFr5.4/tools/klineParse.c
--- ircd-hybrid-6.4.1/tools/klineParse.c	Sun Dec  9 21:56:34 2001
+++ ircd-hyb6.4.1-FDFr5.4/tools/klineParse.c	Wed Oct 15 20:38:23 2003
@@ -5,7 +5,7 @@
  *
  * This program will take a kline.conf and remove duplicate and redundant 
  * entries from it, creating a kline.conf.parsed file
- * $Id: klineParse.c,v 1.3 2001/12/10 02:56:34 jdc Exp $
+ * $Id: klineParse.c,v 1.1.1.1 2003/05/09 01:49:28 jailbird Exp $
  */
 
 #define kParseVer "2.12"
diff -uNrd ircd-hybrid-6.4.1/tools/mkconf ircd-hyb6.4.1-FDFr5.4/tools/mkconf
--- ircd-hybrid-6.4.1/tools/mkconf	Tue Jun 19 13:09:31 2001
+++ ircd-hyb6.4.1-FDFr5.4/tools/mkconf	Wed Oct 15 20:38:23 2003
@@ -1,6 +1,6 @@
 #!/bin/sh
 #
-# $Id: mkconf,v 1.2 2001/06/19 17:09:31 wcampbel Exp $
+# $Id: mkconf,v 1.1.1.1 2003/05/09 01:49:28 jailbird Exp $
 # Copyright (C) 1999 Patrick Alken
 #
 # Usage: ./mkconf [options]
diff -uNrd ircd-hybrid-6.4.1/tools/mkpasswd.c ircd-hyb6.4.1-FDFr5.4/tools/mkpasswd.c
--- ircd-hybrid-6.4.1/tools/mkpasswd.c	Thu May 15 00:19:58 2003
+++ ircd-hyb6.4.1-FDFr5.4/tools/mkpasswd.c	Wed Oct 15 20:38:23 2003
@@ -9,7 +9,7 @@
 ** /dev/random for salt generation added by 
 ** Aaron Sethman <androsyn@ratbox.org>
 **
-** $Id: mkpasswd.c,v 1.12 2003/05/15 04:19:58 db Exp $
+** $Id: mkpasswd.c,v 1.1.1.2 2003/10/09 02:47:15 jailbird Exp $
 */
 #include <stdio.h>
 #include <string.h>
